import { class_type as Reflection_class_type, record_type as Reflection_record_type, bool_type as Reflection_bool_type, list_type as Reflection_list_type, union_type as Reflection_union_type, int32_type as Reflection_int32_type } from "./Reflection.js";
import { value as Option_value, some as Option_some } from "./Option.js";
import { List as Types_List } from "./Types.js";
import { iterate as Seq_iterate, empty as Seq_empty, toIterator as Seq_toIterator, map as Seq_map, unfold as Seq_unfold, getEnumerator as Seq_getEnumerator, fold as Seq_fold } from "./Seq.js";
import { join as String_join, format as String_format } from "./String.js";
import { compare as Util_compare, structuralHash as Util_structuralHash } from "./Util.js";
import { MutableMap$2_$ctor_6623D9B3 as MutableMap_MutableMap$2_$ctor_6623D9B3 } from "./MutableMap.js";

export class MapTree$2 {
    constructor(tag, ...fields) {
        this.tag = (tag | 0);
        this.fields = fields;
    }
    cases() {
        return ["MapEmpty", "MapOne", "MapNode"];
    }
}

export function MapTree$2$reflection(gen0, gen1) {
    return Reflection_union_type("Map.MapTree`2", [gen0, gen1], MapTree$2, () => ([[], [["Item1", gen0], ["Item2", gen1]], [["Item1", gen0], ["Item2", gen1], ["Item3", MapTree$2$reflection(gen0, gen1)], ["Item4", MapTree$2$reflection(gen0, gen1)], ["Item5", Reflection_int32_type]]]));
}

export function MapTreeModule_sizeAux(acc_mut, m_mut) {
    MapTreeModule_sizeAux:
    while (true) {
        const acc = acc_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                return (acc + 1) | 0;
            }
            case 2: {
                acc_mut = MapTreeModule_sizeAux(acc + 1, m.fields[2]);
                m_mut = m.fields[3];
                continue MapTreeModule_sizeAux;
            }
            default: {
                return acc | 0;
            }
        }
        break;
    }
}

export function MapTreeModule_size(x) {
    return MapTreeModule_sizeAux(0, x);
}

export function MapTreeModule_empty() {
    return new MapTree$2(0);
}

export function MapTreeModule_height(_arg1) {
    switch (_arg1.tag) {
        case 1: {
            return 1;
        }
        case 2: {
            return _arg1.fields[4] | 0;
        }
        default: {
            return 0;
        }
    }
}

export function MapTreeModule_isEmpty(m) {
    if (m.tag === 0) {
        return true;
    }
    else {
        return false;
    }
}

export function MapTreeModule_mk(l, k, v, r) {
    let pattern_matching_result;
    if (l.tag === 0) {
        if (r.tag === 0) {
            pattern_matching_result = 0;
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            return new MapTree$2(1, k, v);
        }
        case 1: {
            const hl = MapTreeModule_height(l) | 0;
            const hr = MapTreeModule_height(r) | 0;
            const m = ((hl < hr) ? hr : hl) | 0;
            return new MapTree$2(2, k, v, l, r, m + 1);
        }
    }
}

export function MapTreeModule_rebalance(t1, k, v, t2) {
    const t1h = MapTreeModule_height(t1) | 0;
    const t2h = MapTreeModule_height(t2) | 0;
    if (t2h > (t1h + 2)) {
        if (t2.tag === 2) {
            if (MapTreeModule_height(t2.fields[2]) > (t1h + 1)) {
                if (t2.fields[2].tag === 2) {
                    return MapTreeModule_mk(MapTreeModule_mk(t1, k, v, t2.fields[2].fields[2]), t2.fields[2].fields[0], t2.fields[2].fields[1], MapTreeModule_mk(t2.fields[2].fields[3], t2.fields[0], t2.fields[1], t2.fields[3]));
                }
                else {
                    throw (new Error("rebalance"));
                }
            }
            else {
                return MapTreeModule_mk(MapTreeModule_mk(t1, k, v, t2.fields[2]), t2.fields[0], t2.fields[1], t2.fields[3]);
            }
        }
        else {
            throw (new Error("rebalance"));
        }
    }
    else if (t1h > (t2h + 2)) {
        if (t1.tag === 2) {
            if (MapTreeModule_height(t1.fields[3]) > (t2h + 1)) {
                if (t1.fields[3].tag === 2) {
                    return MapTreeModule_mk(MapTreeModule_mk(t1.fields[2], t1.fields[0], t1.fields[1], t1.fields[3].fields[2]), t1.fields[3].fields[0], t1.fields[3].fields[1], MapTreeModule_mk(t1.fields[3].fields[3], k, v, t2));
                }
                else {
                    throw (new Error("re  balance"));
                }
            }
            else {
                return MapTreeModule_mk(t1.fields[2], t1.fields[0], t1.fields[1], MapTreeModule_mk(t1.fields[3], k, v, t2));
            }
        }
        else {
            throw (new Error("rebalance"));
        }
    }
    else {
        return MapTreeModule_mk(t1, k, v, t2);
    }
}

export function MapTreeModule_add(comparer, k, v, m) {
    switch (m.tag) {
        case 1: {
            const c = comparer.Compare(k, m.fields[0]) | 0;
            if (c < 0) {
                return new MapTree$2(2, k, v, new MapTree$2(0), m, 2);
            }
            else if (c === 0) {
                return new MapTree$2(1, k, v);
            }
            else {
                return new MapTree$2(2, k, v, m, new MapTree$2(0), 2);
            }
        }
        case 2: {
            const c_1 = comparer.Compare(k, m.fields[0]) | 0;
            if (c_1 < 0) {
                return MapTreeModule_rebalance(MapTreeModule_add(comparer, k, v, m.fields[2]), m.fields[0], m.fields[1], m.fields[3]);
            }
            else if (c_1 === 0) {
                return new MapTree$2(2, k, v, m.fields[2], m.fields[3], m.fields[4]);
            }
            else {
                return MapTreeModule_rebalance(m.fields[2], m.fields[0], m.fields[1], MapTreeModule_add(comparer, k, v, m.fields[3]));
            }
        }
        default: {
            return new MapTree$2(1, k, v);
        }
    }
}

export function MapTreeModule_find(comparer_mut, k_mut, m_mut) {
    MapTreeModule_find:
    while (true) {
        const comparer = comparer_mut, k = k_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                const c = comparer.Compare(k, m.fields[0]) | 0;
                if (c === 0) {
                    return m.fields[1];
                }
                else {
                    throw (new Error("key not found"));
                }
            }
            case 2: {
                const c_1 = comparer.Compare(k, m.fields[0]) | 0;
                if (c_1 < 0) {
                    comparer_mut = comparer;
                    k_mut = k;
                    m_mut = m.fields[2];
                    continue MapTreeModule_find;
                }
                else if (c_1 === 0) {
                    return m.fields[1];
                }
                else {
                    comparer_mut = comparer;
                    k_mut = k;
                    m_mut = m.fields[3];
                    continue MapTreeModule_find;
                }
            }
            default: {
                throw (new Error("key not found"));
            }
        }
        break;
    }
}

export function MapTreeModule_tryFind(comparer_mut, k_mut, m_mut) {
    MapTreeModule_tryFind:
    while (true) {
        const comparer = comparer_mut, k = k_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                const c = comparer.Compare(k, m.fields[0]) | 0;
                if (c === 0) {
                    return Option_some(m.fields[1]);
                }
                else {
                    return void 0;
                }
            }
            case 2: {
                const c_1 = comparer.Compare(k, m.fields[0]) | 0;
                if (c_1 < 0) {
                    comparer_mut = comparer;
                    k_mut = k;
                    m_mut = m.fields[2];
                    continue MapTreeModule_tryFind;
                }
                else if (c_1 === 0) {
                    return Option_some(m.fields[1]);
                }
                else {
                    comparer_mut = comparer;
                    k_mut = k;
                    m_mut = m.fields[3];
                    continue MapTreeModule_tryFind;
                }
            }
            default: {
                return void 0;
            }
        }
        break;
    }
}

export function MapTreeModule_partition1(comparer, f, k, v, acc1, acc2) {
    if (f(k, v)) {
        return [MapTreeModule_add(comparer, k, v, acc1), acc2];
    }
    else {
        return [acc1, MapTreeModule_add(comparer, k, v, acc2)];
    }
}

export function MapTreeModule_partitionAux(comparer_mut, f_mut, s_mut, acc_0_mut, acc_1_mut) {
    MapTreeModule_partitionAux:
    while (true) {
        const comparer = comparer_mut, f = f_mut, s = s_mut, acc_0 = acc_0_mut, acc_1 = acc_1_mut;
        switch (s.tag) {
            case 1: {
                return MapTreeModule_partition1(comparer, f, s.fields[0], s.fields[1], acc_0, acc_1);
            }
            case 2: {
                const acc_2 = MapTreeModule_partitionAux(comparer, f, s.fields[3], acc_0, acc_1);
                const acc_3 = MapTreeModule_partition1(comparer, f, s.fields[0], s.fields[1], acc_2[0], acc_2[1]);
                comparer_mut = comparer;
                f_mut = f;
                s_mut = s.fields[2];
                acc_0_mut = acc_3[0];
                acc_1_mut = acc_3[1];
                continue MapTreeModule_partitionAux;
            }
            default: {
                return [acc_0, acc_1];
            }
        }
        break;
    }
}

export function MapTreeModule_partition(comparer, f, s) {
    return MapTreeModule_partitionAux(comparer, f, s, MapTreeModule_empty(), MapTreeModule_empty());
}

export function MapTreeModule_filter1(comparer, f, k, v, acc) {
    if (f(k, v)) {
        return MapTreeModule_add(comparer, k, v, acc);
    }
    else {
        return acc;
    }
}

export function MapTreeModule_filterAux(comparer_mut, f_mut, s_mut, acc_mut) {
    MapTreeModule_filterAux:
    while (true) {
        const comparer = comparer_mut, f = f_mut, s = s_mut, acc = acc_mut;
        switch (s.tag) {
            case 1: {
                return MapTreeModule_filter1(comparer, f, s.fields[0], s.fields[1], acc);
            }
            case 2: {
                const acc_1 = MapTreeModule_filterAux(comparer, f, s.fields[2], acc);
                const acc_2 = MapTreeModule_filter1(comparer, f, s.fields[0], s.fields[1], acc_1);
                comparer_mut = comparer;
                f_mut = f;
                s_mut = s.fields[3];
                acc_mut = acc_2;
                continue MapTreeModule_filterAux;
            }
            default: {
                return acc;
            }
        }
        break;
    }
}

export function MapTreeModule_filter(comparer, f, s) {
    return MapTreeModule_filterAux(comparer, f, s, MapTreeModule_empty());
}

export function MapTreeModule_spliceOutSuccessor(m) {
    switch (m.tag) {
        case 1: {
            return [m.fields[0], m.fields[1], new MapTree$2(0)];
        }
        case 2: {
            if (m.fields[2].tag === 0) {
                return [m.fields[0], m.fields[1], m.fields[3]];
            }
            else {
                const patternInput = MapTreeModule_spliceOutSuccessor(m.fields[2]);
                return [patternInput[0], patternInput[1], MapTreeModule_mk(patternInput[2], m.fields[0], m.fields[1], m.fields[3])];
            }
        }
        default: {
            throw (new Error("internal error: Map.spliceOutSuccessor"));
        }
    }
}

export function MapTreeModule_remove(comparer, k, m) {
    switch (m.tag) {
        case 1: {
            const c = comparer.Compare(k, m.fields[0]) | 0;
            if (c === 0) {
                return new MapTree$2(0);
            }
            else {
                return m;
            }
        }
        case 2: {
            const c_1 = comparer.Compare(k, m.fields[0]) | 0;
            if (c_1 < 0) {
                return MapTreeModule_rebalance(MapTreeModule_remove(comparer, k, m.fields[2]), m.fields[0], m.fields[1], m.fields[3]);
            }
            else if (c_1 === 0) {
                if (m.fields[2].tag === 0) {
                    return m.fields[3];
                }
                else if (m.fields[3].tag === 0) {
                    return m.fields[2];
                }
                else {
                    const patternInput = MapTreeModule_spliceOutSuccessor(m.fields[3]);
                    return MapTreeModule_mk(m.fields[2], patternInput[0], patternInput[1], patternInput[2]);
                }
            }
            else {
                return MapTreeModule_rebalance(m.fields[2], m.fields[0], m.fields[1], MapTreeModule_remove(comparer, k, m.fields[3]));
            }
        }
        default: {
            return MapTreeModule_empty();
        }
    }
}

export function MapTreeModule_mem(comparer_mut, k_mut, m_mut) {
    MapTreeModule_mem:
    while (true) {
        const comparer = comparer_mut, k = k_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                return comparer.Compare(k, m.fields[0]) === 0;
            }
            case 2: {
                const c = comparer.Compare(k, m.fields[0]) | 0;
                if (c < 0) {
                    comparer_mut = comparer;
                    k_mut = k;
                    m_mut = m.fields[2];
                    continue MapTreeModule_mem;
                }
                else if (c === 0) {
                    return true;
                }
                else {
                    comparer_mut = comparer;
                    k_mut = k;
                    m_mut = m.fields[3];
                    continue MapTreeModule_mem;
                }
            }
            default: {
                return false;
            }
        }
        break;
    }
}

export function MapTreeModule_iter(f_mut, m_mut) {
    MapTreeModule_iter:
    while (true) {
        const f = f_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                f(m.fields[0], m.fields[1]);
                break;
            }
            case 2: {
                MapTreeModule_iter(f, m.fields[2]);
                f(m.fields[0], m.fields[1]);
                f_mut = f;
                m_mut = m.fields[3];
                continue MapTreeModule_iter;
                break;
            }
            default: {
            }
        }
        break;
    }
}

export function MapTreeModule_tryPick(f_mut, m_mut) {
    MapTreeModule_tryPick:
    while (true) {
        const f = f_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                return f(m.fields[0], m.fields[1]);
            }
            case 2: {
                const matchValue = MapTreeModule_tryPick(f, m.fields[2]);
                if (matchValue == null) {
                    const matchValue_1 = f(m.fields[0], m.fields[1]);
                    if (matchValue_1 == null) {
                        f_mut = f;
                        m_mut = m.fields[3];
                        continue MapTreeModule_tryPick;
                    }
                    else {
                        return matchValue_1;
                    }
                }
                else {
                    return matchValue;
                }
            }
            default: {
                return void 0;
            }
        }
        break;
    }
}

export function MapTreeModule_exists(f_mut, m_mut) {
    MapTreeModule_exists:
    while (true) {
        const f = f_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                return f(m.fields[0], m.fields[1]);
            }
            case 2: {
                if (MapTreeModule_exists(f, m.fields[2]) ? true : f(m.fields[0], m.fields[1])) {
                    return true;
                }
                else {
                    f_mut = f;
                    m_mut = m.fields[3];
                    continue MapTreeModule_exists;
                }
            }
            default: {
                return false;
            }
        }
        break;
    }
}

export function MapTreeModule_forall(f_mut, m_mut) {
    MapTreeModule_forall:
    while (true) {
        const f = f_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                return f(m.fields[0], m.fields[1]);
            }
            case 2: {
                if (MapTreeModule_forall(f, m.fields[2]) ? f(m.fields[0], m.fields[1]) : false) {
                    f_mut = f;
                    m_mut = m.fields[3];
                    continue MapTreeModule_forall;
                }
                else {
                    return false;
                }
            }
            default: {
                return true;
            }
        }
        break;
    }
}

export function MapTreeModule_map(f, m) {
    switch (m.tag) {
        case 1: {
            return new MapTree$2(1, m.fields[0], f(m.fields[1]));
        }
        case 2: {
            const l2 = MapTreeModule_map(f, m.fields[2]);
            const v2 = f(m.fields[1]);
            const r2 = MapTreeModule_map(f, m.fields[3]);
            return new MapTree$2(2, m.fields[0], v2, l2, r2, m.fields[4]);
        }
        default: {
            return MapTreeModule_empty();
        }
    }
}

export function MapTreeModule_mapi(f, m) {
    switch (m.tag) {
        case 1: {
            return new MapTree$2(1, m.fields[0], f(m.fields[0], m.fields[1]));
        }
        case 2: {
            const l2 = MapTreeModule_mapi(f, m.fields[2]);
            const v2 = f(m.fields[0], m.fields[1]);
            const r2 = MapTreeModule_mapi(f, m.fields[3]);
            return new MapTree$2(2, m.fields[0], v2, l2, r2, m.fields[4]);
        }
        default: {
            return MapTreeModule_empty();
        }
    }
}

export function MapTreeModule_foldBack(f_mut, m_mut, x_mut) {
    MapTreeModule_foldBack:
    while (true) {
        const f = f_mut, m = m_mut, x = x_mut;
        switch (m.tag) {
            case 1: {
                return f(m.fields[0], m.fields[1], x);
            }
            case 2: {
                const x_1 = MapTreeModule_foldBack(f, m.fields[3], x);
                const x_2 = f(m.fields[0], m.fields[1], x_1);
                f_mut = f;
                m_mut = m.fields[2];
                x_mut = x_2;
                continue MapTreeModule_foldBack;
            }
            default: {
                return x;
            }
        }
        break;
    }
}

export function MapTreeModule_fold(f_mut, x_mut, m_mut) {
    MapTreeModule_fold:
    while (true) {
        const f = f_mut, x = x_mut, m = m_mut;
        switch (m.tag) {
            case 1: {
                return f(x, m.fields[0], m.fields[1]);
            }
            case 2: {
                const x_1 = MapTreeModule_fold(f, x, m.fields[2]);
                const x_2 = f(x_1, m.fields[0], m.fields[1]);
                f_mut = f;
                x_mut = x_2;
                m_mut = m.fields[3];
                continue MapTreeModule_fold;
            }
            default: {
                return x;
            }
        }
        break;
    }
}

export function MapTreeModule_foldFromTo(comparer, lo, hi, f, m, x) {
    switch (m.tag) {
        case 1: {
            const cLoKey = comparer.Compare(lo, m.fields[0]) | 0;
            const cKeyHi = comparer.Compare(m.fields[0], hi) | 0;
            const x_1 = ((cLoKey <= 0) ? (cKeyHi <= 0) : false) ? f(m.fields[0], m.fields[1], x) : x;
            return x_1;
        }
        case 2: {
            const cLoKey_1 = comparer.Compare(lo, m.fields[0]) | 0;
            const cKeyHi_1 = comparer.Compare(m.fields[0], hi) | 0;
            const x_2 = (cLoKey_1 < 0) ? MapTreeModule_foldFromTo(comparer, lo, hi, f, m.fields[2], x) : x;
            const x_3 = ((cLoKey_1 <= 0) ? (cKeyHi_1 <= 0) : false) ? f(m.fields[0], m.fields[1], x_2) : x_2;
            const x_4 = (cKeyHi_1 < 0) ? MapTreeModule_foldFromTo(comparer, lo, hi, f, m.fields[3], x_3) : x_3;
            return x_4;
        }
        default: {
            return x;
        }
    }
}

export function MapTreeModule_foldSection(comparer, lo, hi, f, m, x) {
    if (comparer.Compare(lo, hi) === 1) {
        return x;
    }
    else {
        return MapTreeModule_foldFromTo(comparer, lo, hi, f, m, x);
    }
}

export function MapTreeModule_loop(m_mut, acc_mut) {
    MapTreeModule_loop:
    while (true) {
        const m = m_mut, acc = acc_mut;
        switch (m.tag) {
            case 1: {
                return new Types_List([m.fields[0], m.fields[1]], acc);
            }
            case 2: {
                m_mut = m.fields[2];
                acc_mut = (new Types_List([m.fields[0], m.fields[1]], MapTreeModule_loop(m.fields[3], acc)));
                continue MapTreeModule_loop;
            }
            default: {
                return acc;
            }
        }
        break;
    }
}

export function MapTreeModule_toList(m) {
    return MapTreeModule_loop(m, new Types_List());
}

export function MapTreeModule_ofList(comparer, l) {
    return Seq_fold((acc, tupledArg) => MapTreeModule_add(comparer, tupledArg[0], tupledArg[1], acc), MapTreeModule_empty(), l);
}

export function MapTreeModule_mkFromEnumerator(comparer_mut, acc_mut, e_mut) {
    MapTreeModule_mkFromEnumerator:
    while (true) {
        const comparer = comparer_mut, acc = acc_mut, e = e_mut;
        if (e.MoveNext()) {
            const patternInput = e.Current;
            comparer_mut = comparer;
            acc_mut = MapTreeModule_add(comparer, patternInput[0], patternInput[1], acc);
            e_mut = e;
            continue MapTreeModule_mkFromEnumerator;
        }
        else {
            return acc;
        }
        break;
    }
}

export function MapTreeModule_ofArray(comparer, arr) {
    let res = MapTreeModule_empty();
    for (let i = 0; i <= (arr.length - 1); i++) {
        const patternInput = arr[i];
        res = MapTreeModule_add(comparer, patternInput[0], patternInput[1], res);
    }
    return res;
}

export function MapTreeModule_ofSeq(comparer, c) {
    const ie = Seq_getEnumerator(c);
    try {
        return MapTreeModule_mkFromEnumerator(comparer, MapTreeModule_empty(), ie);
    }
    finally {
        ie.Dispose();
    }
}

export function MapTreeModule_copyToArray(s, arr, i) {
    let j = i | 0;
    MapTreeModule_iter((x, y) => {
        arr[j] = ([x, y]);
        j = (j + 1);
    }, s);
}

export class MapTreeModule_MapIterator$2 {
    constructor(stack, started) {
        this.stack = stack;
        this.started = started;
    }
}

export function MapTreeModule_MapIterator$2$reflection(gen0, gen1) {
    return Reflection_record_type("Map.MapTreeModule.MapIterator`2", [gen0, gen1], MapTreeModule_MapIterator$2, () => ([["stack", Reflection_list_type(MapTree$2$reflection(gen0, gen1))], ["started", Reflection_bool_type]]));
}

export function MapTreeModule_collapseLHS(stack_mut) {
    MapTreeModule_collapseLHS:
    while (true) {
        const stack = stack_mut;
        if (stack.tail != null) {
            if (stack.head.tag === 1) {
                return stack;
            }
            else if (stack.head.tag === 2) {
                stack_mut = (new Types_List(stack.head.fields[2], new Types_List(new MapTree$2(1, stack.head.fields[0], stack.head.fields[1]), new Types_List(stack.head.fields[3], stack.tail))));
                continue MapTreeModule_collapseLHS;
            }
            else {
                stack_mut = stack.tail;
                continue MapTreeModule_collapseLHS;
            }
        }
        else {
            return new Types_List();
        }
        break;
    }
}

export function MapTreeModule_mkIterator(s) {
    return new MapTreeModule_MapIterator$2(MapTreeModule_collapseLHS(new Types_List(s, new Types_List())), false);
}

export function MapTreeModule_notStarted() {
    throw (new Error("enumeration not started"));
}

export function MapTreeModule_alreadyFinished() {
    throw (new Error("enumeration already finished"));
}

export function MapTreeModule_current(i) {
    if (i.started) {
        const matchValue = i.stack;
        if (matchValue.tail == null) {
            return MapTreeModule_alreadyFinished();
        }
        else if (matchValue.head.tag === 1) {
            return [matchValue.head.fields[0], matchValue.head.fields[1]];
        }
        else {
            throw (new Error("Please report error: Map iterator, unexpected stack for current"));
        }
    }
    else {
        return MapTreeModule_notStarted();
    }
}

export function MapTreeModule_moveNext(i) {
    if (i.started) {
        const matchValue = i.stack;
        if (matchValue.tail == null) {
            return false;
        }
        else if (matchValue.head.tag === 1) {
            i.stack = MapTreeModule_collapseLHS(matchValue.tail);
            return !(i.stack.tail == null);
        }
        else {
            throw (new Error("Please report error: Map iterator, unexpected stack for moveNext"));
        }
    }
    else {
        i.started = true;
        return !(i.stack.tail == null);
    }
}

export class MapTreeModule_mkIEnumerator$0027$2 {
    constructor(s) {
        this.s = s;
        this.i = MapTreeModule_mkIterator(this.s);
    }
    ["System.Collections.Generic.IEnumerator`1.get_Current"]() {
        const __ = this;
        return MapTreeModule_current(__.i);
    }
    get Current() {
        const __ = this;
        return MapTreeModule_current(__.i);
    }
    MoveNext() {
        const __ = this;
        return MapTreeModule_moveNext(__.i);
    }
    Reset() {
        const __ = this;
        __.i = MapTreeModule_mkIterator(__.s);
    }
    Dispose() {
        const __ = this;
    }
}

export function MapTreeModule_mkIEnumerator$0027$2$reflection(gen0, gen1) {
    return Reflection_class_type("Map.MapTreeModule.mkIEnumerator\u0027`2", [gen0, gen1], MapTreeModule_mkIEnumerator$0027$2);
}

export function MapTreeModule_mkIEnumerator$0027$2_$ctor_Z26BC498C(s) {
    return new MapTreeModule_mkIEnumerator$0027$2(s);
}

export function MapTreeModule_mkIEnumerator(s) {
    return MapTreeModule_mkIEnumerator$0027$2_$ctor_Z26BC498C(s);
}

export function MapTreeModule_toSeq(s) {
    const en = MapTreeModule_mkIEnumerator(s);
    return Seq_unfold((en_1) => {
        if (en_1.MoveNext()) {
            return [en_1.Current, en_1];
        }
        else {
            return void 0;
        }
    }, en);
}

export class FSharpMap {
    constructor(comparer, tree) {
        this.comparer = comparer;
        this.tree = tree;
    }
    ToString() {
        const this$ = this;
        let str;
        let strings;
        strings = Seq_map((kv) => String_format("({0}, {1})", kv[0], kv[1]), this$);
        str = String_join("; ", strings);
        return ("map [" + str) + "]";
    }
    toString() {
        return this.ToString();
    }
    GetHashCode() {
        const this$ = this;
        const combineHash = (x, y) => (((x << 1) + y) + 631);
        let res = 0;
        const e = MapTreeModule_mkIEnumerator(FSharpMap__get_Tree(this$));
        while (e.MoveNext()) {
            const patternInput = e.Current;
            const activePatternResult4167 = patternInput;
            res = combineHash(res, Util_structuralHash(activePatternResult4167[0]));
            res = combineHash(res, Util_structuralHash(activePatternResult4167[1]));
        }
        return Math.abs(res) | 0;
    }
    Equals(that) {
        const this$ = this;
        return this$.CompareTo(that) === 0;
    }
    GetEnumerator() {
        const __ = this;
        return MapTreeModule_mkIEnumerator(__.tree);
    }
    [Symbol.iterator]() {
        return Seq_toIterator(this.GetEnumerator());
    }
    ["System.Collections.IEnumerable.GetEnumerator"]() {
        const __ = this;
        return MapTreeModule_mkIEnumerator(__.tree);
    }
    CompareTo(obj) {
        const m = this;
        let res = 0;
        let finished = false;
        const e1 = MapTreeModule_mkIEnumerator(FSharpMap__get_Tree(m));
        try {
            const e2 = MapTreeModule_mkIEnumerator(FSharpMap__get_Tree(obj));
            try {
                while ((!finished) ? (res === 0) : false) {
                    const matchValue = [e1.MoveNext(), e2.MoveNext()];
                    if (matchValue[0]) {
                        if (matchValue[1]) {
                            const kvp1 = e1.Current;
                            const kvp2 = e2.Current;
                            const c = m.comparer.Compare(kvp1[0], kvp2[0]) | 0;
                            res = ((c !== 0) ? c : Util_compare(kvp1[1], kvp2[1]));
                        }
                        else {
                            res = 1;
                        }
                    }
                    else if (matchValue[1]) {
                        res = -1;
                    }
                    else {
                        finished = true;
                    }
                }
                return res | 0;
            }
            finally {
                e2.Dispose();
            }
        }
        finally {
            e1.Dispose();
        }
    }
    get size() {
        const this$ = this;
        return FSharpMap__get_Count(this$) | 0;
    }
    clear() {
        const __ = this;
        throw (new Error("Map cannot be mutated"));
    }
    delete(_arg1) {
        const __ = this;
        throw (new Error("Map cannot be mutated"));
    }
    entries() {
        const this$ = this;
        return MapTreeModule_toSeq(FSharpMap__get_Tree(this$));
    }
    get(k) {
        const this$ = this;
        return FSharpMap__get_Item_2B595(this$, k);
    }
    has(k) {
        const this$ = this;
        return FSharpMap__ContainsKey_2B595(this$, k);
    }
    keys() {
        const this$ = this;
        const source = MapTreeModule_toSeq(FSharpMap__get_Tree(this$));
        return Seq_map((kv) => kv[0], source);
    }
    set(k, v) {
        const __ = this;
        throw (new Error("Map cannot be mutated"));
    }
    values() {
        const this$ = this;
        const source = MapTreeModule_toSeq(FSharpMap__get_Tree(this$));
        return Seq_map((kv) => kv[1], source);
    }
}

export function FSharpMap$reflection(gen0, gen1) {
    return Reflection_class_type("Map.FSharpMap", [gen0, gen1], FSharpMap);
}

export function FSharpMap_$ctor_58ADD115(comparer, tree) {
    return new FSharpMap(comparer, tree);
}

export function FSharpMap__get_Comparer(__) {
    return __.comparer;
}

export function FSharpMap__get_Tree(__) {
    return __.tree;
}

export function FSharpMap__Add_5BDDA1(__, k, v) {
    return FSharpMap_$ctor_58ADD115(__.comparer, MapTreeModule_add(__.comparer, k, v, __.tree));
}

export function FSharpMap__get_IsEmpty(__) {
    return MapTreeModule_isEmpty(__.tree);
}

export function FSharpMap__get_Item_2B595(__, k) {
    return MapTreeModule_find(__.comparer, k, __.tree);
}

export function FSharpMap__TryGetValue_5BDDA1(__, k, defValue) {
    const matchValue = MapTreeModule_tryFind(__.comparer, k, __.tree);
    if (matchValue == null) {
        return [false, defValue];
    }
    else {
        const v = Option_value(matchValue);
        return [true, v];
    }
}

export function FSharpMap__TryPick_72321DD7(__, f) {
    return MapTreeModule_tryPick(f, __.tree);
}

export function FSharpMap__Exists_Z395DDC35(__, f) {
    return MapTreeModule_exists(f, __.tree);
}

export function FSharpMap__Filter_Z395DDC35(__, f) {
    return FSharpMap_$ctor_58ADD115(__.comparer, MapTreeModule_filter(__.comparer, f, __.tree));
}

export function FSharpMap__ForAll_Z395DDC35(__, f) {
    return MapTreeModule_forall(f, __.tree);
}

export function FSharpMap__Fold(__, f, acc) {
    return MapTreeModule_foldBack(f, __.tree, acc);
}

export function FSharpMap__FoldSection(__, lo, hi, f, acc) {
    return MapTreeModule_foldSection(__.comparer, lo, hi, f, __.tree, acc);
}

export function FSharpMap__Iterate_1DCFB91D(__, f) {
    MapTreeModule_iter(f, __.tree);
}

export function FSharpMap__MapRange_6DC7247(__, f) {
    return FSharpMap_$ctor_58ADD115(__.comparer, MapTreeModule_map(f, __.tree));
}

export function FSharpMap__Map_Z6F6B671C(__, f) {
    return FSharpMap_$ctor_58ADD115(__.comparer, MapTreeModule_mapi(f, __.tree));
}

export function FSharpMap__Partition_Z395DDC35(__, f) {
    const patternInput = MapTreeModule_partition(__.comparer, f, __.tree);
    return [FSharpMap_$ctor_58ADD115(__.comparer, patternInput[0]), FSharpMap_$ctor_58ADD115(__.comparer, patternInput[1])];
}

export function FSharpMap__get_Count(__) {
    return MapTreeModule_size(__.tree);
}

export function FSharpMap__ContainsKey_2B595(__, k) {
    return MapTreeModule_mem(__.comparer, k, __.tree);
}

export function FSharpMap__Remove_2B595(__, k) {
    return FSharpMap_$ctor_58ADD115(__.comparer, MapTreeModule_remove(__.comparer, k, __.tree));
}

export function FSharpMap__TryFind_2B595(__, k) {
    return MapTreeModule_tryFind(__.comparer, k, __.tree);
}

export function FSharpMap__ToList(__) {
    return MapTreeModule_toList(__.tree);
}

export function isEmpty(m) {
    return FSharpMap__get_IsEmpty(m);
}

export function add(k, v, m) {
    return FSharpMap__Add_5BDDA1(m, k, v);
}

export function find(k, m) {
    return FSharpMap__get_Item_2B595(m, k);
}

export function tryFind(k, m) {
    return FSharpMap__TryFind_2B595(m, k);
}

export function remove(k, m) {
    return FSharpMap__Remove_2B595(m, k);
}

export function containsKey(k, m) {
    return FSharpMap__ContainsKey_2B595(m, k);
}

export function iterate(f, m) {
    FSharpMap__Iterate_1DCFB91D(m, f);
}

export function tryPick(f, m) {
    return FSharpMap__TryPick_72321DD7(m, f);
}

export function pick(f, m) {
    const matchValue = tryPick(f, m);
    if (matchValue != null) {
        const res = Option_value(matchValue);
        return res;
    }
    else {
        throw (new Error("key not found"));
    }
}

export function exists(f, m) {
    return FSharpMap__Exists_Z395DDC35(m, f);
}

export function filter(f, m) {
    return FSharpMap__Filter_Z395DDC35(m, f);
}

export function partition(f, m) {
    return FSharpMap__Partition_Z395DDC35(m, f);
}

export function forAll(f, m) {
    return FSharpMap__ForAll_Z395DDC35(m, f);
}

export function mapRange(f, m) {
    return FSharpMap__MapRange_6DC7247(m, f);
}

export function map(f, m) {
    return FSharpMap__Map_Z6F6B671C(m, f);
}

export function fold(f, z, m) {
    return MapTreeModule_fold(f, z, FSharpMap__get_Tree(m));
}

export function foldBack(f, m, z) {
    return MapTreeModule_foldBack(f, FSharpMap__get_Tree(m), z);
}

export function toSeq(m) {
    return MapTreeModule_toSeq(FSharpMap__get_Tree(m));
}

export function findKey(f, m) {
    let _arg1;
    const m_1 = FSharpMap__get_Tree(m);
    _arg1 = MapTreeModule_tryPick((k, v) => {
        if (f(k, v)) {
            return Option_some(k);
        }
        else {
            return void 0;
        }
    }, m_1);
    if (_arg1 == null) {
        throw (new Error("Key not found"));
    }
    else {
        const k_1 = Option_value(_arg1);
        return k_1;
    }
}

export function tryFindKey(f, m) {
    const m_1 = FSharpMap__get_Tree(m);
    return MapTreeModule_tryPick((k, v) => {
        if (f(k, v)) {
            return Option_some(k);
        }
        else {
            return void 0;
        }
    }, m_1);
}

export function ofList(l, comparer) {
    return FSharpMap_$ctor_58ADD115(comparer, MapTreeModule_ofList(comparer, l));
}

export function ofSeq(l, comparer) {
    return FSharpMap_$ctor_58ADD115(comparer, MapTreeModule_ofSeq(comparer, l));
}

export function ofArray(array, comparer) {
    return FSharpMap_$ctor_58ADD115(comparer, MapTreeModule_ofArray(comparer, array));
}

export function toList(m) {
    return FSharpMap__ToList(m);
}

export function toArray(m) {
    let res;
    const len = FSharpMap__get_Count(m) | 0;
    res = (new (Array)(len));
    MapTreeModule_copyToArray(FSharpMap__get_Tree(m), res, 0);
    return res;
}

export function empty(comparer) {
    return FSharpMap_$ctor_58ADD115(comparer, new MapTree$2(0));
}

export function createMutable(source, comparer) {
    const map_1 = MutableMap_MutableMap$2_$ctor_6623D9B3(source, comparer);
    return map_1;
}

export function groupBy(projection, xs, comparer) {
    const dict = createMutable(Seq_empty(), comparer);
    Seq_iterate((v) => {
        const key = projection(v);
        if (dict.has(key)) {
            void (dict.get(key).push(v));
        }
        else {
            const value = dict.set(key, [v]);
            void value;
        }
    }, xs);
    return Seq_map((kv) => ([kv[0], kv[1]]), dict);
}

export function countBy(projection, xs, comparer) {
    const dict = createMutable(Seq_empty(), comparer);
    Seq_iterate((value) => {
        const key = projection(value);
        const value_1 = dict.has(key) ? dict.set(key, dict.get(key) + 1) : dict.set(key, 1);
        void value_1;
    }, xs);
    return Seq_map((kv) => ([kv[0], kv[1]]), dict);
}

export function count(m) {
    return FSharpMap__get_Count(m);
}

