import { sumBy as Seq_sumBy, iterate as Seq_iterate, iterateIndexed as Seq_iterateIndexed, toIterator as Seq_toIterator, delay as Seq_delay, collect as Seq_collect, map as Seq_map, getEnumerator as Seq_getEnumerator } from "./Seq.js";
import { FSharpRef as Types_FSharpRef } from "./Types.js";
import { class_type as Reflection_class_type } from "./Reflection.js";
import { getItemFromDict as Util_getItemFromDict, tryGetValue as Util_tryGetValue } from "./Util.js";
import { some as Option_some } from "./Option.js";

export class MutableSet$1 {
    constructor(items, comparer) {
        const this$ = new Types_FSharpRef(null);
        this.comparer = comparer;
        this$.contents = this;
        this.hashMap = (new Map([]));
        this["init@21-2"] = 1;
        Seq_iterate((item) => {
            const value = MutableSet$1__Add_2B595(this$.contents, item);
            void value;
        }, items);
    }
    ["System.Collections.IEnumerable.GetEnumerator"]() {
        const this$ = this;
        return Seq_getEnumerator(this$);
    }
    GetEnumerator() {
        const this$ = this;
        const elems = Seq_delay(() => Seq_collect((values) => Seq_map((value) => value, values), this$.hashMap.values()));
        return Seq_getEnumerator(elems);
    }
    [Symbol.iterator]() {
        return Seq_toIterator(this.GetEnumerator());
    }
    ["System.Collections.Generic.ICollection`1.Add2B595"](item) {
        const this$ = this;
        const value = MutableSet$1__Add_2B595(this$, item);
        void value;
    }
    ["System.Collections.Generic.ICollection`1.Clear"]() {
        const this$ = this;
        MutableSet$1__Clear(this$);
    }
    ["System.Collections.Generic.ICollection`1.Contains2B595"](item) {
        const this$ = this;
        return MutableSet$1__Contains_2B595(this$, item);
    }
    ["System.Collections.Generic.ICollection`1.CopyToZ2E171D71"](array, arrayIndex) {
        const this$ = this;
        Seq_iterateIndexed((i, e) => {
            array[arrayIndex + i] = e;
        }, this$);
    }
    ["System.Collections.Generic.ICollection`1.get_Count"]() {
        const this$ = this;
        return MutableSet$1__get_Count(this$) | 0;
    }
    ["System.Collections.Generic.ICollection`1.get_IsReadOnly"]() {
        const this$ = this;
        return false;
    }
    ["System.Collections.Generic.ICollection`1.Remove2B595"](item) {
        const this$ = this;
        return MutableSet$1__Remove_2B595(this$, item);
    }
    get size() {
        const this$ = this;
        return MutableSet$1__get_Count(this$) | 0;
    }
    add(k) {
        const this$ = this;
        const value = MutableSet$1__Add_2B595(this$, k);
        void value;
        return this$;
    }
    add_(k) {
        const this$ = this;
        return MutableSet$1__Add_2B595(this$, k);
    }
    clear() {
        const this$ = this;
        MutableSet$1__Clear(this$);
    }
    delete(k) {
        const this$ = this;
        return MutableSet$1__Remove_2B595(this$, k);
    }
    has(k) {
        const this$ = this;
        return MutableSet$1__Contains_2B595(this$, k);
    }
    keys() {
        const this$ = this;
        return Seq_map((x) => x, this$);
    }
    values() {
        const this$ = this;
        return Seq_map((x) => x, this$);
    }
    entries() {
        const this$ = this;
        return Seq_map((v) => ([v, v]), this$);
    }
}

export function MutableSet$1$reflection(gen0) {
    return Reflection_class_type("Fable.Collections.MutableSet`1", [gen0], MutableSet$1);
}

export function MutableSet$1_$ctor_Z6150332D(items, comparer) {
    return new MutableSet$1(items, comparer);
}

function MutableSet$1__TryFindIndex_2B595(this$, k) {
    const h = this$.comparer.GetHashCode(k) | 0;
    const matchValue = Util_tryGetValue(this$.hashMap, h, null);
    if (matchValue[0]) {
        return [true, h, matchValue[1].findIndex((v) => this$.comparer.Equals(k, v))];
    }
    else {
        return [false, h, -1];
    }
}

function MutableSet$1__TryFind_2B595(this$, k) {
    const matchValue = MutableSet$1__TryFindIndex_2B595(this$, k);
    let pattern_matching_result;
    if (matchValue[0]) {
        if (matchValue[2] > -1) {
            pattern_matching_result = 0;
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            return Option_some(Util_getItemFromDict(this$.hashMap, matchValue[1])[matchValue[2]]);
        }
        case 1: {
            return void 0;
        }
    }
}

export function MutableSet$1__get_Comparer(this$) {
    return this$.comparer;
}

export function MutableSet$1__Clear(this$) {
    this$.hashMap.clear();
}

export function MutableSet$1__get_Count(this$) {
    const source = this$.hashMap.values();
    return Seq_sumBy((pairs) => pairs.length, source, {
        GetZero: () => 0,
        Add: (x, y) => (x + y),
    }) | 0;
}

export function MutableSet$1__Add_2B595(this$, k) {
    const matchValue = MutableSet$1__TryFindIndex_2B595(this$, k);
    let pattern_matching_result;
    if (matchValue[0]) {
        if (matchValue[2] > -1) {
            pattern_matching_result = 0;
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            return false;
        }
        case 1: {
            if (matchValue[0]) {
                const value = void (Util_getItemFromDict(this$.hashMap, matchValue[1]).push(k));
                void undefined;
                return true;
            }
            else {
                this$.hashMap.set(matchValue[1], [k]);
                return true;
            }
        }
    }
}

export function MutableSet$1__Contains_2B595(this$, k) {
    const matchValue = MutableSet$1__TryFindIndex_2B595(this$, k);
    let pattern_matching_result;
    if (matchValue[0]) {
        if (matchValue[2] > -1) {
            pattern_matching_result = 0;
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            return true;
        }
        case 1: {
            return false;
        }
    }
}

export function MutableSet$1__Remove_2B595(this$, k) {
    const matchValue = MutableSet$1__TryFindIndex_2B595(this$, k);
    let pattern_matching_result;
    if (matchValue[0]) {
        if (matchValue[2] > -1) {
            pattern_matching_result = 0;
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            Util_getItemFromDict(this$.hashMap, matchValue[1]).splice(matchValue[2], 1);
            return true;
        }
        case 1: {
            return false;
        }
    }
}

