import { class_type as Reflection_class_type, record_type as Reflection_record_type, bool_type as Reflection_bool_type, list_type as Reflection_list_type, union_type as Reflection_union_type, int32_type as Reflection_int32_type } from "./Reflection.js";
import { value as Option_value, some as Option_some, Choice as Option_Choice } from "./Option.js";
import { List as Types_List } from "./Types.js";
import { iterate as Seq_iterate, delay as Seq_delay, collect as Seq_collect, singleton as Seq_singleton, empty as Seq_empty, fold as Seq_fold, reduce as Seq_reduce, toIterator as Seq_toIterator, map as Seq_map, getEnumerator as Seq_getEnumerator, unfold as Seq_unfold } from "./Seq.js";
import { join as String_join } from "./String.js";
import { structuralHash as Util_structuralHash } from "./Util.js";
import { MutableSet$1__Add_2B595 as MutableSet_MutableSet$1__Add_2B595, MutableSet$1_$ctor_Z6150332D as MutableSet_MutableSet$1_$ctor_Z6150332D } from "./MutableSet.js";

export class SetTree$1 {
    constructor(tag, ...fields) {
        this.tag = (tag | 0);
        this.fields = fields;
    }
    cases() {
        return ["SetEmpty", "SetNode", "SetOne"];
    }
}

export function SetTree$1$reflection(gen0) {
    return Reflection_union_type("Set.SetTree`1", [gen0], SetTree$1, () => ([[], [["Item1", gen0], ["Item2", SetTree$1$reflection(gen0)], ["Item3", SetTree$1$reflection(gen0)], ["Item4", Reflection_int32_type]], [["Item", gen0]]]));
}

export function SetTreeModule_countAux(s_mut, acc_mut) {
    SetTreeModule_countAux:
    while (true) {
        const s = s_mut, acc = acc_mut;
        switch (s.tag) {
            case 2: {
                return (acc + 1) | 0;
            }
            case 0: {
                return acc | 0;
            }
            default: {
                s_mut = s.fields[1];
                acc_mut = SetTreeModule_countAux(s.fields[2], acc + 1);
                continue SetTreeModule_countAux;
            }
        }
        break;
    }
}

export function SetTreeModule_count(s) {
    return SetTreeModule_countAux(s, 0);
}

export function SetTreeModule_SetOne(n) {
    return new SetTree$1(2, n);
}

export function SetTreeModule_SetNode(x, l, r, h) {
    return new SetTree$1(1, x, l, r, h);
}

export function SetTreeModule_height(t) {
    switch (t.tag) {
        case 2: {
            return 1;
        }
        case 1: {
            return t.fields[3] | 0;
        }
        default: {
            return 0;
        }
    }
}

export const SetTreeModule_tolerance = 2;

export function SetTreeModule_mk(l, k, r) {
    let pattern_matching_result;
    if (l.tag === 0) {
        if (r.tag === 0) {
            pattern_matching_result = 0;
        }
        else {
            pattern_matching_result = 1;
        }
    }
    else {
        pattern_matching_result = 1;
    }
    switch (pattern_matching_result) {
        case 0: {
            return SetTreeModule_SetOne(k);
        }
        case 1: {
            const hl = SetTreeModule_height(l) | 0;
            const hr = SetTreeModule_height(r) | 0;
            const m = ((hl < hr) ? hr : hl) | 0;
            return SetTreeModule_SetNode(k, l, r, m + 1);
        }
    }
}

export function SetTreeModule_rebalance(t1, k, t2) {
    const t1h = SetTreeModule_height(t1) | 0;
    const t2h = SetTreeModule_height(t2) | 0;
    if (t2h > (t1h + SetTreeModule_tolerance)) {
        if (t2.tag === 1) {
            if (SetTreeModule_height(t2.fields[1]) > (t1h + 1)) {
                if (t2.fields[1].tag === 1) {
                    return SetTreeModule_mk(SetTreeModule_mk(t1, k, t2.fields[1].fields[1]), t2.fields[1].fields[0], SetTreeModule_mk(t2.fields[1].fields[2], t2.fields[0], t2.fields[2]));
                }
                else {
                    throw (new Error("rebalance"));
                }
            }
            else {
                return SetTreeModule_mk(SetTreeModule_mk(t1, k, t2.fields[1]), t2.fields[0], t2.fields[2]);
            }
        }
        else {
            throw (new Error("rebalance"));
        }
    }
    else if (t1h > (t2h + SetTreeModule_tolerance)) {
        if (t1.tag === 1) {
            if (SetTreeModule_height(t1.fields[2]) > (t2h + 1)) {
                if (t1.fields[2].tag === 1) {
                    return SetTreeModule_mk(SetTreeModule_mk(t1.fields[1], t1.fields[0], t1.fields[2].fields[1]), t1.fields[2].fields[0], SetTreeModule_mk(t1.fields[2].fields[2], k, t2));
                }
                else {
                    throw (new Error("rebalance"));
                }
            }
            else {
                return SetTreeModule_mk(t1.fields[1], t1.fields[0], SetTreeModule_mk(t1.fields[2], k, t2));
            }
        }
        else {
            throw (new Error("rebalance"));
        }
    }
    else {
        return SetTreeModule_mk(t1, k, t2);
    }
}

export function SetTreeModule_add(comparer, k, t) {
    switch (t.tag) {
        case 2: {
            const c_1 = comparer.Compare(k, t.fields[0]) | 0;
            if (c_1 < 0) {
                return SetTreeModule_SetNode(k, new SetTree$1(0), t, 2);
            }
            else if (c_1 === 0) {
                return t;
            }
            else {
                return SetTreeModule_SetNode(k, t, new SetTree$1(0), 2);
            }
        }
        case 0: {
            return SetTreeModule_SetOne(k);
        }
        default: {
            const c = comparer.Compare(k, t.fields[0]) | 0;
            if (c < 0) {
                return SetTreeModule_rebalance(SetTreeModule_add(comparer, k, t.fields[1]), t.fields[0], t.fields[2]);
            }
            else if (c === 0) {
                return t;
            }
            else {
                return SetTreeModule_rebalance(t.fields[1], t.fields[0], SetTreeModule_add(comparer, k, t.fields[2]));
            }
        }
    }
}

export function SetTreeModule_balance(comparer, t1, k, t2) {
    let pattern_matching_result, t2_1, t1_1, k1, t2_2, k2, t1_2, h1, h2, k1_1, k2_1, t11, t12, t21, t22;
    if (t1.tag === 2) {
        if (t2.tag === 0) {
            pattern_matching_result = 1;
            t1_1 = t1;
        }
        else if (t2.tag === 2) {
            pattern_matching_result = 2;
            k1 = t1.fields[0];
            t2_2 = t2;
        }
        else {
            pattern_matching_result = 2;
            k1 = t1.fields[0];
            t2_2 = t2;
        }
    }
    else if (t1.tag === 1) {
        if (t2.tag === 2) {
            pattern_matching_result = 3;
            k2 = t2.fields[0];
            t1_2 = t1;
        }
        else if (t2.tag === 1) {
            pattern_matching_result = 4;
            h1 = t1.fields[3];
            h2 = t2.fields[3];
            k1_1 = t1.fields[0];
            k2_1 = t2.fields[0];
            t11 = t1.fields[1];
            t12 = t1.fields[2];
            t21 = t2.fields[1];
            t22 = t2.fields[2];
        }
        else {
            pattern_matching_result = 1;
            t1_1 = t1;
        }
    }
    else {
        pattern_matching_result = 0;
        t2_1 = t2;
    }
    switch (pattern_matching_result) {
        case 0: {
            return SetTreeModule_add(comparer, k, t2_1);
        }
        case 1: {
            return SetTreeModule_add(comparer, k, t1_1);
        }
        case 2: {
            return SetTreeModule_add(comparer, k, SetTreeModule_add(comparer, k1, t2_2));
        }
        case 3: {
            return SetTreeModule_add(comparer, k, SetTreeModule_add(comparer, k2, t1_2));
        }
        case 4: {
            if ((h1 + SetTreeModule_tolerance) < h2) {
                return SetTreeModule_rebalance(SetTreeModule_balance(comparer, t1, k, t21), k2_1, t22);
            }
            else if ((h2 + SetTreeModule_tolerance) < h1) {
                return SetTreeModule_rebalance(t11, k1_1, SetTreeModule_balance(comparer, t12, k, t2));
            }
            else {
                return SetTreeModule_mk(t1, k, t2);
            }
        }
    }
}

export function SetTreeModule_split(comparer, pivot, t) {
    switch (t.tag) {
        case 2: {
            const c_1 = comparer.Compare(t.fields[0], pivot) | 0;
            if (c_1 < 0) {
                return [t, false, new SetTree$1(0)];
            }
            else if (c_1 === 0) {
                return [new SetTree$1(0), true, new SetTree$1(0)];
            }
            else {
                return [new SetTree$1(0), false, t];
            }
        }
        case 0: {
            return [new SetTree$1(0), false, new SetTree$1(0)];
        }
        default: {
            const c = comparer.Compare(pivot, t.fields[0]) | 0;
            if (c < 0) {
                const patternInput = SetTreeModule_split(comparer, pivot, t.fields[1]);
                return [patternInput[0], patternInput[1], SetTreeModule_balance(comparer, patternInput[2], t.fields[0], t.fields[2])];
            }
            else if (c === 0) {
                return [t.fields[1], true, t.fields[2]];
            }
            else {
                const patternInput_1 = SetTreeModule_split(comparer, pivot, t.fields[2]);
                return [SetTreeModule_balance(comparer, t.fields[1], t.fields[0], patternInput_1[0]), patternInput_1[1], patternInput_1[2]];
            }
        }
    }
}

export function SetTreeModule_spliceOutSuccessor(t) {
    switch (t.tag) {
        case 2: {
            return [t.fields[0], new SetTree$1(0)];
        }
        case 1: {
            if (t.fields[1].tag === 0) {
                return [t.fields[0], t.fields[2]];
            }
            else {
                const patternInput = SetTreeModule_spliceOutSuccessor(t.fields[1]);
                return [patternInput[0], SetTreeModule_mk(patternInput[1], t.fields[0], t.fields[2])];
            }
        }
        default: {
            throw (new Error("internal error: Set.spliceOutSuccessor"));
        }
    }
}

export function SetTreeModule_remove(comparer, k, t) {
    switch (t.tag) {
        case 2: {
            const c = comparer.Compare(k, t.fields[0]) | 0;
            if (c === 0) {
                return new SetTree$1(0);
            }
            else {
                return t;
            }
        }
        case 1: {
            const c_1 = comparer.Compare(k, t.fields[0]) | 0;
            if (c_1 < 0) {
                return SetTreeModule_rebalance(SetTreeModule_remove(comparer, k, t.fields[1]), t.fields[0], t.fields[2]);
            }
            else if (c_1 === 0) {
                if (t.fields[1].tag === 0) {
                    return t.fields[2];
                }
                else if (t.fields[2].tag === 0) {
                    return t.fields[1];
                }
                else {
                    const patternInput = SetTreeModule_spliceOutSuccessor(t.fields[2]);
                    return SetTreeModule_mk(t.fields[1], patternInput[0], patternInput[1]);
                }
            }
            else {
                return SetTreeModule_rebalance(t.fields[1], t.fields[0], SetTreeModule_remove(comparer, k, t.fields[2]));
            }
        }
        default: {
            return t;
        }
    }
}

export function SetTreeModule_mem(comparer_mut, k_mut, t_mut) {
    SetTreeModule_mem:
    while (true) {
        const comparer = comparer_mut, k = k_mut, t = t_mut;
        switch (t.tag) {
            case 2: {
                return comparer.Compare(k, t.fields[0]) === 0;
            }
            case 0: {
                return false;
            }
            default: {
                const c = comparer.Compare(k, t.fields[0]) | 0;
                if (c < 0) {
                    comparer_mut = comparer;
                    k_mut = k;
                    t_mut = t.fields[1];
                    continue SetTreeModule_mem;
                }
                else if (c === 0) {
                    return true;
                }
                else {
                    comparer_mut = comparer;
                    k_mut = k;
                    t_mut = t.fields[2];
                    continue SetTreeModule_mem;
                }
            }
        }
        break;
    }
}

export function SetTreeModule_iter(f_mut, t_mut) {
    SetTreeModule_iter:
    while (true) {
        const f = f_mut, t = t_mut;
        switch (t.tag) {
            case 2: {
                f(t.fields[0]);
                break;
            }
            case 0: {
                break;
            }
            default: {
                SetTreeModule_iter(f, t.fields[1]);
                f(t.fields[0]);
                f_mut = f;
                t_mut = t.fields[2];
                continue SetTreeModule_iter;
            }
        }
        break;
    }
}

export function SetTreeModule_foldBack(f_mut, m_mut, x_mut) {
    SetTreeModule_foldBack:
    while (true) {
        const f = f_mut, m = m_mut, x = x_mut;
        switch (m.tag) {
            case 2: {
                return f(m.fields[0], x);
            }
            case 0: {
                return x;
            }
            default: {
                f_mut = f;
                m_mut = m.fields[1];
                x_mut = f(m.fields[0], SetTreeModule_foldBack(f, m.fields[2], x));
                continue SetTreeModule_foldBack;
            }
        }
        break;
    }
}

export function SetTreeModule_fold(f_mut, x_mut, m_mut) {
    SetTreeModule_fold:
    while (true) {
        const f = f_mut, x = x_mut, m = m_mut;
        switch (m.tag) {
            case 2: {
                return f(x, m.fields[0]);
            }
            case 0: {
                return x;
            }
            default: {
                const x_1 = SetTreeModule_fold(f, x, m.fields[1]);
                const x_2 = f(x_1, m.fields[0]);
                f_mut = f;
                x_mut = x_2;
                m_mut = m.fields[2];
                continue SetTreeModule_fold;
            }
        }
        break;
    }
}

export function SetTreeModule_forall(f_mut, m_mut) {
    SetTreeModule_forall:
    while (true) {
        const f = f_mut, m = m_mut;
        switch (m.tag) {
            case 2: {
                return f(m.fields[0]);
            }
            case 0: {
                return true;
            }
            default: {
                if (f(m.fields[0]) ? SetTreeModule_forall(f, m.fields[1]) : false) {
                    f_mut = f;
                    m_mut = m.fields[2];
                    continue SetTreeModule_forall;
                }
                else {
                    return false;
                }
            }
        }
        break;
    }
}

export function SetTreeModule_exists(f_mut, m_mut) {
    SetTreeModule_exists:
    while (true) {
        const f = f_mut, m = m_mut;
        switch (m.tag) {
            case 2: {
                return f(m.fields[0]);
            }
            case 0: {
                return false;
            }
            default: {
                if (f(m.fields[0]) ? true : SetTreeModule_exists(f, m.fields[1])) {
                    return true;
                }
                else {
                    f_mut = f;
                    m_mut = m.fields[2];
                    continue SetTreeModule_exists;
                }
            }
        }
        break;
    }
}

export function SetTreeModule_isEmpty(m) {
    if (m.tag === 0) {
        return true;
    }
    else {
        return false;
    }
}

export function SetTreeModule_subset(comparer, a, b) {
    return SetTreeModule_forall((x) => SetTreeModule_mem(comparer, x, b), a);
}

export function SetTreeModule_psubset(comparer, a, b) {
    if (SetTreeModule_forall((x) => SetTreeModule_mem(comparer, x, b), a)) {
        return SetTreeModule_exists((x_1) => (!SetTreeModule_mem(comparer, x_1, a)), b);
    }
    else {
        return false;
    }
}

export function SetTreeModule_filterAux(comparer_mut, f_mut, s_mut, acc_mut) {
    SetTreeModule_filterAux:
    while (true) {
        const comparer = comparer_mut, f = f_mut, s = s_mut, acc = acc_mut;
        switch (s.tag) {
            case 2: {
                if (f(s.fields[0])) {
                    return SetTreeModule_add(comparer, s.fields[0], acc);
                }
                else {
                    return acc;
                }
            }
            case 0: {
                return acc;
            }
            default: {
                const acc_1 = f(s.fields[0]) ? SetTreeModule_add(comparer, s.fields[0], acc) : acc;
                comparer_mut = comparer;
                f_mut = f;
                s_mut = s.fields[1];
                acc_mut = SetTreeModule_filterAux(comparer, f, s.fields[2], acc_1);
                continue SetTreeModule_filterAux;
            }
        }
        break;
    }
}

export function SetTreeModule_filter(comparer, f, s) {
    return SetTreeModule_filterAux(comparer, f, s, new SetTree$1(0));
}

export function SetTreeModule_diffAux(comparer_mut, m_mut, acc_mut) {
    SetTreeModule_diffAux:
    while (true) {
        const comparer = comparer_mut, m = m_mut, acc = acc_mut;
        switch (m.tag) {
            case 2: {
                return SetTreeModule_remove(comparer, m.fields[0], acc);
            }
            case 0: {
                return acc;
            }
            default: {
                comparer_mut = comparer;
                m_mut = m.fields[1];
                acc_mut = SetTreeModule_diffAux(comparer, m.fields[2], SetTreeModule_remove(comparer, m.fields[0], acc));
                continue SetTreeModule_diffAux;
            }
        }
        break;
    }
}

export function SetTreeModule_diff(comparer, a, b) {
    return SetTreeModule_diffAux(comparer, b, a);
}

export function SetTreeModule_union(comparer, t1, t2) {
    let pattern_matching_result, h1, h2, k1, k2, t11, t12, t21, t22, t, t_1, k1_1, t2_1, k2_1, t1_1;
    if (t1.tag === 0) {
        pattern_matching_result = 1;
        t = t2;
    }
    else if (t1.tag === 2) {
        if (t2.tag === 0) {
            pattern_matching_result = 2;
            t_1 = t1;
        }
        else if (t2.tag === 2) {
            pattern_matching_result = 3;
            k1_1 = t1.fields[0];
            t2_1 = t2;
        }
        else {
            pattern_matching_result = 3;
            k1_1 = t1.fields[0];
            t2_1 = t2;
        }
    }
    else if (t2.tag === 0) {
        pattern_matching_result = 2;
        t_1 = t1;
    }
    else if (t2.tag === 2) {
        pattern_matching_result = 4;
        k2_1 = t2.fields[0];
        t1_1 = t1;
    }
    else {
        pattern_matching_result = 0;
        h1 = t1.fields[3];
        h2 = t2.fields[3];
        k1 = t1.fields[0];
        k2 = t2.fields[0];
        t11 = t1.fields[1];
        t12 = t1.fields[2];
        t21 = t2.fields[1];
        t22 = t2.fields[2];
    }
    switch (pattern_matching_result) {
        case 0: {
            if (h1 > h2) {
                const patternInput = SetTreeModule_split(comparer, k1, t2);
                return SetTreeModule_balance(comparer, SetTreeModule_union(comparer, t11, patternInput[0]), k1, SetTreeModule_union(comparer, t12, patternInput[2]));
            }
            else {
                const patternInput_1 = SetTreeModule_split(comparer, k2, t1);
                return SetTreeModule_balance(comparer, SetTreeModule_union(comparer, t21, patternInput_1[0]), k2, SetTreeModule_union(comparer, t22, patternInput_1[2]));
            }
        }
        case 1: {
            return t;
        }
        case 2: {
            return t_1;
        }
        case 3: {
            return SetTreeModule_add(comparer, k1_1, t2_1);
        }
        case 4: {
            return SetTreeModule_add(comparer, k2_1, t1_1);
        }
    }
}

export function SetTreeModule_intersectionAux(comparer_mut, b_mut, m_mut, acc_mut) {
    SetTreeModule_intersectionAux:
    while (true) {
        const comparer = comparer_mut, b = b_mut, m = m_mut, acc = acc_mut;
        switch (m.tag) {
            case 2: {
                if (SetTreeModule_mem(comparer, m.fields[0], b)) {
                    return SetTreeModule_add(comparer, m.fields[0], acc);
                }
                else {
                    return acc;
                }
            }
            case 0: {
                return acc;
            }
            default: {
                const acc_1 = SetTreeModule_intersectionAux(comparer, b, m.fields[2], acc);
                const acc_2 = SetTreeModule_mem(comparer, m.fields[0], b) ? SetTreeModule_add(comparer, m.fields[0], acc_1) : acc_1;
                comparer_mut = comparer;
                b_mut = b;
                m_mut = m.fields[1];
                acc_mut = acc_2;
                continue SetTreeModule_intersectionAux;
            }
        }
        break;
    }
}

export function SetTreeModule_intersection(comparer, a, b) {
    return SetTreeModule_intersectionAux(comparer, b, a, new SetTree$1(0));
}

export function SetTreeModule_partition1(comparer, f, k, acc1, acc2) {
    if (f(k)) {
        return [SetTreeModule_add(comparer, k, acc1), acc2];
    }
    else {
        return [acc1, SetTreeModule_add(comparer, k, acc2)];
    }
}

export function SetTreeModule_partitionAux(comparer_mut, f_mut, s_mut, acc_0_mut, acc_1_mut) {
    SetTreeModule_partitionAux:
    while (true) {
        const comparer = comparer_mut, f = f_mut, s = s_mut, acc_0 = acc_0_mut, acc_1 = acc_1_mut;
        switch (s.tag) {
            case 2: {
                return SetTreeModule_partition1(comparer, f, s.fields[0], acc_0, acc_1);
            }
            case 0: {
                return [acc_0, acc_1];
            }
            default: {
                const acc_2 = SetTreeModule_partitionAux(comparer, f, s.fields[2], acc_0, acc_1);
                const acc_3 = SetTreeModule_partition1(comparer, f, s.fields[0], acc_2[0], acc_2[1]);
                comparer_mut = comparer;
                f_mut = f;
                s_mut = s.fields[1];
                acc_0_mut = acc_3[0];
                acc_1_mut = acc_3[1];
                continue SetTreeModule_partitionAux;
            }
        }
        break;
    }
}

export function SetTreeModule_partition(comparer, f, s) {
    const seed = [new SetTree$1(0), new SetTree$1(0)];
    return SetTreeModule_partitionAux(comparer, f, s, seed[0], seed[1]);
}

export function SetTreeModule_$007CMatchSetNode$007CMatchSetEmpty$007C(s) {
    switch (s.tag) {
        case 2: {
            return new Option_Choice(0, [s.fields[0], new SetTree$1(0), new SetTree$1(0)]);
        }
        case 0: {
            return new Option_Choice(1, void 0);
        }
        default: {
            return new Option_Choice(0, [s.fields[0], s.fields[1], s.fields[2]]);
        }
    }
}

export function SetTreeModule_minimumElementAux(s_mut, n_mut) {
    SetTreeModule_minimumElementAux:
    while (true) {
        const s = s_mut, n = n_mut;
        switch (s.tag) {
            case 2: {
                return s.fields[0];
            }
            case 0: {
                return n;
            }
            default: {
                s_mut = s.fields[1];
                n_mut = s.fields[0];
                continue SetTreeModule_minimumElementAux;
            }
        }
        break;
    }
}

export function SetTreeModule_minimumElementOpt(s) {
    switch (s.tag) {
        case 2: {
            return Option_some(s.fields[0]);
        }
        case 0: {
            return void 0;
        }
        default: {
            return Option_some(SetTreeModule_minimumElementAux(s.fields[1], s.fields[0]));
        }
    }
}

export function SetTreeModule_maximumElementAux(s_mut, n_mut) {
    SetTreeModule_maximumElementAux:
    while (true) {
        const s = s_mut, n = n_mut;
        switch (s.tag) {
            case 2: {
                return s.fields[0];
            }
            case 0: {
                return n;
            }
            default: {
                s_mut = s.fields[2];
                n_mut = s.fields[0];
                continue SetTreeModule_maximumElementAux;
            }
        }
        break;
    }
}

export function SetTreeModule_maximumElementOpt(s) {
    switch (s.tag) {
        case 2: {
            return Option_some(s.fields[0]);
        }
        case 0: {
            return void 0;
        }
        default: {
            return Option_some(SetTreeModule_maximumElementAux(s.fields[2], s.fields[0]));
        }
    }
}

export function SetTreeModule_minimumElement(s) {
    const matchValue = SetTreeModule_minimumElementOpt(s);
    if (matchValue == null) {
        throw (new Error("Set contains no elements"));
    }
    else {
        const k = Option_value(matchValue);
        return k;
    }
}

export function SetTreeModule_maximumElement(s) {
    const matchValue = SetTreeModule_maximumElementOpt(s);
    if (matchValue == null) {
        throw (new Error("Set contains no elements"));
    }
    else {
        const k = Option_value(matchValue);
        return k;
    }
}

export class SetTreeModule_SetIterator$1 {
    constructor(stack, started) {
        this.stack = stack;
        this.started = started;
    }
}

export function SetTreeModule_SetIterator$1$reflection(gen0) {
    return Reflection_record_type("Set.SetTreeModule.SetIterator`1", [gen0], SetTreeModule_SetIterator$1, () => ([["stack", Reflection_list_type(SetTree$1$reflection(gen0))], ["started", Reflection_bool_type]]));
}

export function SetTreeModule_collapseLHS(stack_mut) {
    SetTreeModule_collapseLHS:
    while (true) {
        const stack = stack_mut;
        if (stack.tail != null) {
            if (stack.head.tag === 2) {
                return stack;
            }
            else if (stack.head.tag === 1) {
                stack_mut = (new Types_List(stack.head.fields[1], new Types_List(SetTreeModule_SetOne(stack.head.fields[0]), new Types_List(stack.head.fields[2], stack.tail))));
                continue SetTreeModule_collapseLHS;
            }
            else {
                stack_mut = stack.tail;
                continue SetTreeModule_collapseLHS;
            }
        }
        else {
            return new Types_List();
        }
        break;
    }
}

export function SetTreeModule_mkIterator(s) {
    return new SetTreeModule_SetIterator$1(SetTreeModule_collapseLHS(new Types_List(s, new Types_List())), false);
}

export function SetTreeModule_notStarted() {
    throw (new Error("Enumeration not started"));
}

export function SetTreeModule_alreadyFinished() {
    throw (new Error("Enumeration already started"));
}

export function SetTreeModule_current(i) {
    if (i.started) {
        const matchValue = i.stack;
        if (matchValue.tail == null) {
            return SetTreeModule_alreadyFinished();
        }
        else if (matchValue.head.tag === 2) {
            return matchValue.head.fields[0];
        }
        else {
            throw (new Error("Please report error: Set iterator, unexpected stack for current"));
        }
    }
    else {
        return SetTreeModule_notStarted();
    }
}

export function SetTreeModule_moveNext(i) {
    if (i.started) {
        const matchValue = i.stack;
        if (matchValue.tail == null) {
            return false;
        }
        else if (matchValue.head.tag === 2) {
            i.stack = SetTreeModule_collapseLHS(matchValue.tail);
            return !(i.stack.tail == null);
        }
        else {
            throw (new Error("Please report error: Set iterator, unexpected stack for moveNext"));
        }
    }
    else {
        i.started = true;
        return !(i.stack.tail == null);
    }
}

export class SetTreeModule_mkIEnumerator$1 {
    constructor(s) {
        this.s = s;
        this.i = SetTreeModule_mkIterator(this.s);
    }
    ["System.Collections.Generic.IEnumerator`1.get_Current"]() {
        const __ = this;
        return SetTreeModule_current(__.i);
    }
    get Current() {
        const __ = this;
        return SetTreeModule_current(__.i);
    }
    MoveNext() {
        const __ = this;
        return SetTreeModule_moveNext(__.i);
    }
    Reset() {
        const __ = this;
        __.i = SetTreeModule_mkIterator(__.s);
    }
    Dispose() {
        const __ = this;
    }
}

export function SetTreeModule_mkIEnumerator$1$reflection(gen0) {
    return Reflection_class_type("Set.SetTreeModule.mkIEnumerator`1", [gen0], SetTreeModule_mkIEnumerator$1);
}

export function SetTreeModule_mkIEnumerator$1_$ctor_Z5B395D56(s) {
    return new SetTreeModule_mkIEnumerator$1(s);
}

export function SetTreeModule_mkIEnumerator(s) {
    return SetTreeModule_mkIEnumerator$1_$ctor_Z5B395D56(s);
}

export function SetTreeModule_toSeq(s) {
    const en = SetTreeModule_mkIEnumerator(s);
    return Seq_unfold((en_1) => {
        if (en_1.MoveNext()) {
            return [en_1.Current, en_1];
        }
        else {
            return void 0;
        }
    }, en);
}

export function SetTreeModule_compareStacks(comparer_mut, l1_mut, l2_mut) {
    SetTreeModule_compareStacks:
    while (true) {
        const comparer = comparer_mut, l1 = l1_mut, l2 = l2_mut;
        let pattern_matching_result, t1, t2, n1k, n2k, t1_1, t2_1, n1k_1, n2k_1, n2r, t1_2, t2_2, emp, n1k_2, n1r, n2k_2, t1_3, t2_3, n1k_3, n1r_1, n2k_3, n2r_1, t1_4, t2_4, n1k_4, t1_5, n1k_5, n1l, n1r_2, t1_6, n2k_4, t2_5, n2k_5, n2l, n2r_2, t2_6;
        if (l1.tail != null) {
            if (l2.tail != null) {
                if (l2.head.tag === 2) {
                    if (l1.head.tag === 2) {
                        pattern_matching_result = 4;
                        n1k = l1.head.fields[0];
                        n2k = l2.head.fields[0];
                        t1_1 = l1.tail;
                        t2_1 = l2.tail;
                    }
                    else if (l1.head.tag === 1) {
                        if (l1.head.fields[1].tag === 0) {
                            pattern_matching_result = 6;
                            emp = l1.head.fields[1];
                            n1k_2 = l1.head.fields[0];
                            n1r = l1.head.fields[2];
                            n2k_2 = l2.head.fields[0];
                            t1_3 = l1.tail;
                            t2_3 = l2.tail;
                        }
                        else {
                            pattern_matching_result = 9;
                            n1k_5 = l1.head.fields[0];
                            n1l = l1.head.fields[1];
                            n1r_2 = l1.head.fields[2];
                            t1_6 = l1.tail;
                        }
                    }
                    else {
                        pattern_matching_result = 10;
                        n2k_4 = l2.head.fields[0];
                        t2_5 = l2.tail;
                    }
                }
                else if (l2.head.tag === 1) {
                    if (l2.head.fields[1].tag === 0) {
                        if (l1.head.tag === 2) {
                            pattern_matching_result = 5;
                            n1k_1 = l1.head.fields[0];
                            n2k_1 = l2.head.fields[0];
                            n2r = l2.head.fields[2];
                            t1_2 = l1.tail;
                            t2_2 = l2.tail;
                        }
                        else if (l1.head.tag === 1) {
                            if (l1.head.fields[1].tag === 0) {
                                pattern_matching_result = 7;
                                n1k_3 = l1.head.fields[0];
                                n1r_1 = l1.head.fields[2];
                                n2k_3 = l2.head.fields[0];
                                n2r_1 = l2.head.fields[2];
                                t1_4 = l1.tail;
                                t2_4 = l2.tail;
                            }
                            else {
                                pattern_matching_result = 9;
                                n1k_5 = l1.head.fields[0];
                                n1l = l1.head.fields[1];
                                n1r_2 = l1.head.fields[2];
                                t1_6 = l1.tail;
                            }
                        }
                        else {
                            pattern_matching_result = 11;
                            n2k_5 = l2.head.fields[0];
                            n2l = l2.head.fields[1];
                            n2r_2 = l2.head.fields[2];
                            t2_6 = l2.tail;
                        }
                    }
                    else if (l1.head.tag === 2) {
                        pattern_matching_result = 8;
                        n1k_4 = l1.head.fields[0];
                        t1_5 = l1.tail;
                    }
                    else if (l1.head.tag === 1) {
                        pattern_matching_result = 9;
                        n1k_5 = l1.head.fields[0];
                        n1l = l1.head.fields[1];
                        n1r_2 = l1.head.fields[2];
                        t1_6 = l1.tail;
                    }
                    else {
                        pattern_matching_result = 11;
                        n2k_5 = l2.head.fields[0];
                        n2l = l2.head.fields[1];
                        n2r_2 = l2.head.fields[2];
                        t2_6 = l2.tail;
                    }
                }
                else if (l1.head.tag === 2) {
                    pattern_matching_result = 8;
                    n1k_4 = l1.head.fields[0];
                    t1_5 = l1.tail;
                }
                else if (l1.head.tag === 1) {
                    pattern_matching_result = 9;
                    n1k_5 = l1.head.fields[0];
                    n1l = l1.head.fields[1];
                    n1r_2 = l1.head.fields[2];
                    t1_6 = l1.tail;
                }
                else {
                    pattern_matching_result = 3;
                    t1 = l1.tail;
                    t2 = l2.tail;
                }
            }
            else {
                pattern_matching_result = 2;
            }
        }
        else if (l2.tail != null) {
            pattern_matching_result = 1;
        }
        else {
            pattern_matching_result = 0;
        }
        switch (pattern_matching_result) {
            case 0: {
                return 0;
            }
            case 1: {
                return -1;
            }
            case 2: {
                return 1;
            }
            case 3: {
                comparer_mut = comparer;
                l1_mut = t1;
                l2_mut = t2;
                continue SetTreeModule_compareStacks;
            }
            case 4: {
                const c = comparer.Compare(n1k, n2k) | 0;
                if (c !== 0) {
                    return c | 0;
                }
                else {
                    comparer_mut = comparer;
                    l1_mut = t1_1;
                    l2_mut = t2_1;
                    continue SetTreeModule_compareStacks;
                }
            }
            case 5: {
                const c_1 = comparer.Compare(n1k_1, n2k_1) | 0;
                if (c_1 !== 0) {
                    return c_1 | 0;
                }
                else {
                    comparer_mut = comparer;
                    l1_mut = (new Types_List(new SetTree$1(0), t1_2));
                    l2_mut = (new Types_List(n2r, t2_2));
                    continue SetTreeModule_compareStacks;
                }
            }
            case 6: {
                const c_2 = comparer.Compare(n1k_2, n2k_2) | 0;
                if (c_2 !== 0) {
                    return c_2 | 0;
                }
                else {
                    comparer_mut = comparer;
                    l1_mut = (new Types_List(n1r, t1_3));
                    l2_mut = (new Types_List(emp, t2_3));
                    continue SetTreeModule_compareStacks;
                }
            }
            case 7: {
                const c_3 = comparer.Compare(n1k_3, n2k_3) | 0;
                if (c_3 !== 0) {
                    return c_3 | 0;
                }
                else {
                    comparer_mut = comparer;
                    l1_mut = (new Types_List(n1r_1, t1_4));
                    l2_mut = (new Types_List(n2r_1, t2_4));
                    continue SetTreeModule_compareStacks;
                }
            }
            case 8: {
                comparer_mut = comparer;
                l1_mut = (new Types_List(new SetTree$1(0), new Types_List(SetTreeModule_SetOne(n1k_4), t1_5)));
                l2_mut = l2;
                continue SetTreeModule_compareStacks;
            }
            case 9: {
                comparer_mut = comparer;
                l1_mut = (new Types_List(n1l, new Types_List(SetTreeModule_SetNode(n1k_5, new SetTree$1(0), n1r_2, 0), t1_6)));
                l2_mut = l2;
                continue SetTreeModule_compareStacks;
            }
            case 10: {
                comparer_mut = comparer;
                l1_mut = l1;
                l2_mut = (new Types_List(new SetTree$1(0), new Types_List(SetTreeModule_SetOne(n2k_4), t2_5)));
                continue SetTreeModule_compareStacks;
            }
            case 11: {
                comparer_mut = comparer;
                l1_mut = l1;
                l2_mut = (new Types_List(n2l, new Types_List(SetTreeModule_SetNode(n2k_5, new SetTree$1(0), n2r_2, 0), t2_6)));
                continue SetTreeModule_compareStacks;
            }
        }
        break;
    }
}

export function SetTreeModule_compare(comparer, s1, s2) {
    if (s1.tag === 0) {
        if (s2.tag === 0) {
            return 0;
        }
        else {
            return -1;
        }
    }
    else if (s2.tag === 0) {
        return 1;
    }
    else {
        return SetTreeModule_compareStacks(comparer, new Types_List(s1, new Types_List()), new Types_List(s2, new Types_List())) | 0;
    }
}

export function SetTreeModule_choose(s) {
    return SetTreeModule_minimumElement(s);
}

export function SetTreeModule_loop(m_mut, acc_mut) {
    SetTreeModule_loop:
    while (true) {
        const m = m_mut, acc = acc_mut;
        switch (m.tag) {
            case 2: {
                return new Types_List(m.fields[0], acc);
            }
            case 0: {
                return acc;
            }
            default: {
                m_mut = m.fields[1];
                acc_mut = (new Types_List(m.fields[0], SetTreeModule_loop(m.fields[2], acc)));
                continue SetTreeModule_loop;
            }
        }
        break;
    }
}

export function SetTreeModule_toList(s) {
    return SetTreeModule_loop(s, new Types_List());
}

export function SetTreeModule_copyToArray(s, arr, i) {
    let j = i | 0;
    SetTreeModule_iter((x) => {
        arr[j] = x;
        j = (j + 1);
    }, s);
}

export function SetTreeModule_mkFromEnumerator(comparer_mut, acc_mut, e_mut) {
    SetTreeModule_mkFromEnumerator:
    while (true) {
        const comparer = comparer_mut, acc = acc_mut, e = e_mut;
        if (e.MoveNext()) {
            comparer_mut = comparer;
            acc_mut = SetTreeModule_add(comparer, e.Current, acc);
            e_mut = e;
            continue SetTreeModule_mkFromEnumerator;
        }
        else {
            return acc;
        }
        break;
    }
}

export function SetTreeModule_ofSeq(comparer, c) {
    const ie = Seq_getEnumerator(c);
    try {
        return SetTreeModule_mkFromEnumerator(comparer, new SetTree$1(0), ie);
    }
    finally {
        ie.Dispose();
    }
}

export function SetTreeModule_ofArray(comparer, arr) {
    let acc = new SetTree$1(0);
    for (let i = 0; i <= (arr.length - 1); i++) {
        acc = SetTreeModule_add(comparer, arr[i], acc);
    }
    return acc;
}

export class FSharpSet {
    constructor(comparer, tree) {
        this.comparer = comparer;
        this.tree = tree;
    }
    ToString() {
        let strings;
        const this$ = this;
        return ("set [" + (strings = Seq_map((x) => {
            let copyOfStruct = x;
            return String(copyOfStruct);
        }, this$), (String_join("; ", strings)))) + "]";
    }
    toString() {
        return this.ToString();
    }
    GetHashCode() {
        const this$ = this;
        let res = 0;
        const e = SetTreeModule_mkIEnumerator(FSharpSet__get_Tree(this$));
        while (e.MoveNext()) {
            const x = res | 0;
            const y = Util_structuralHash(e.Current) | 0;
            res = (((x << 1) + y) + 631);
        }
        return Math.abs(res) | 0;
    }
    Equals(that) {
        const this$ = this;
        return SetTreeModule_compare(FSharpSet__get_Comparer(this$), FSharpSet__get_Tree(this$), FSharpSet__get_Tree(that)) === 0;
    }
    CompareTo(that) {
        const this$ = this;
        return SetTreeModule_compare(FSharpSet__get_Comparer(this$), FSharpSet__get_Tree(this$), FSharpSet__get_Tree(that)) | 0;
    }
    GetEnumerator() {
        const s = this;
        return SetTreeModule_mkIEnumerator(FSharpSet__get_Tree(s));
    }
    [Symbol.iterator]() {
        return Seq_toIterator(this.GetEnumerator());
    }
    ["System.Collections.IEnumerable.GetEnumerator"]() {
        const s = this;
        return SetTreeModule_mkIEnumerator(FSharpSet__get_Tree(s));
    }
}

export function FSharpSet$reflection(gen0) {
    return Reflection_class_type("Set.FSharpSet", [gen0], FSharpSet);
}

export function FSharpSet_$ctor_2528C5CB(comparer, tree) {
    return new FSharpSet(comparer, tree);
}

export function FSharpSet__get_Comparer(__) {
    return __.comparer;
}

export function FSharpSet__get_Tree(__) {
    return __.tree;
}

export function FSharpSet__Add_2B595(s, x) {
    return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), SetTreeModule_add(FSharpSet__get_Comparer(s), x, FSharpSet__get_Tree(s)));
}

export function FSharpSet__Remove_2B595(s, x) {
    return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), SetTreeModule_remove(FSharpSet__get_Comparer(s), x, FSharpSet__get_Tree(s)));
}

export function FSharpSet__get_Count(s) {
    return SetTreeModule_count(FSharpSet__get_Tree(s));
}

export function FSharpSet__Contains_2B595(s, x) {
    return SetTreeModule_mem(FSharpSet__get_Comparer(s), x, FSharpSet__get_Tree(s));
}

export function FSharpSet__Iterate_5028453F(s, x) {
    SetTreeModule_iter(x, FSharpSet__get_Tree(s));
}

export function FSharpSet__Fold(s, f, z) {
    return SetTreeModule_fold((x, z_1) => f(z_1, x), z, FSharpSet__get_Tree(s));
}

export function FSharpSet__get_IsEmpty(s) {
    return SetTreeModule_isEmpty(FSharpSet__get_Tree(s));
}

export function FSharpSet__Partition_Z1D55A0D7(s, f) {
    const matchValue = FSharpSet__get_Tree(s);
    if (matchValue.tag === 0) {
        return [s, s];
    }
    else {
        const patternInput = SetTreeModule_partition(FSharpSet__get_Comparer(s), f, FSharpSet__get_Tree(s));
        return [FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), patternInput[0]), FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), patternInput[1])];
    }
}

export function FSharpSet__Filter_Z1D55A0D7(s, f) {
    const matchValue = FSharpSet__get_Tree(s);
    if (matchValue.tag === 0) {
        return s;
    }
    else {
        return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(s), SetTreeModule_filter(FSharpSet__get_Comparer(s), f, FSharpSet__get_Tree(s)));
    }
}

export function FSharpSet__Map_7597B8F7(s, f, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_fold((acc, k) => SetTreeModule_add(comparer, f(k), acc), new SetTree$1(0), FSharpSet__get_Tree(s)));
}

export function FSharpSet__Exists_Z1D55A0D7(s, f) {
    return SetTreeModule_exists(f, FSharpSet__get_Tree(s));
}

export function FSharpSet__ForAll_Z1D55A0D7(s, f) {
    return SetTreeModule_forall(f, FSharpSet__get_Tree(s));
}

export function FSharpSet_op_Subtraction(a, b) {
    const matchValue = FSharpSet__get_Tree(a);
    if (matchValue.tag === 0) {
        return a;
    }
    else {
        const matchValue_1 = FSharpSet__get_Tree(b);
        if (matchValue_1.tag === 0) {
            return a;
        }
        else {
            return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(a), SetTreeModule_diff(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b)));
        }
    }
}

export function FSharpSet_op_Addition(a, b) {
    const matchValue = FSharpSet__get_Tree(b);
    if (matchValue.tag === 0) {
        return a;
    }
    else {
        const matchValue_1 = FSharpSet__get_Tree(a);
        if (matchValue_1.tag === 0) {
            return b;
        }
        else {
            return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(a), SetTreeModule_union(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b)));
        }
    }
}

export function FSharpSet_Intersection_Z3BE9BFE0(a, b) {
    const matchValue = FSharpSet__get_Tree(b);
    if (matchValue.tag === 0) {
        return b;
    }
    else {
        const matchValue_1 = FSharpSet__get_Tree(a);
        if (matchValue_1.tag === 0) {
            return a;
        }
        else {
            return FSharpSet_$ctor_2528C5CB(FSharpSet__get_Comparer(a), SetTreeModule_intersection(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b)));
        }
    }
}

export function FSharpSet_IntersectionMany_Z15B59630(sets) {
    return Seq_reduce(FSharpSet_Intersection_Z3BE9BFE0, sets);
}

export function FSharpSet_Equality_Z3BE9BFE0(a, b) {
    return SetTreeModule_compare(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b)) === 0;
}

export function FSharpSet_Compare_Z3BE9BFE0(a, b) {
    return SetTreeModule_compare(FSharpSet__get_Comparer(a), FSharpSet__get_Tree(a), FSharpSet__get_Tree(b));
}

export function FSharpSet__get_Choose(x) {
    return SetTreeModule_choose(FSharpSet__get_Tree(x));
}

export function FSharpSet__get_MinimumElement(x) {
    return SetTreeModule_minimumElement(FSharpSet__get_Tree(x));
}

export function FSharpSet__get_MaximumElement(x) {
    return SetTreeModule_maximumElement(FSharpSet__get_Tree(x));
}

export function FSharpSet__IsSubsetOf_6A20B1FF(x, y) {
    return SetTreeModule_subset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(x), FSharpSet__get_Tree(y));
}

export function FSharpSet__IsSupersetOf_6A20B1FF(x, y) {
    return SetTreeModule_subset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(y), FSharpSet__get_Tree(x));
}

export function FSharpSet__IsProperSubsetOf_6A20B1FF(x, y) {
    return SetTreeModule_psubset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(x), FSharpSet__get_Tree(y));
}

export function FSharpSet__IsProperSupersetOf_6A20B1FF(x, y) {
    return SetTreeModule_psubset(FSharpSet__get_Comparer(x), FSharpSet__get_Tree(y), FSharpSet__get_Tree(x));
}

export function isEmpty(s) {
    return FSharpSet__get_IsEmpty(s);
}

export function contains(x, s) {
    return FSharpSet__Contains_2B595(s, x);
}

export function add(x, s) {
    return FSharpSet__Add_2B595(s, x);
}

export function singleton(x, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, new SetTree$1(2, x));
}

export function remove(x, s) {
    return FSharpSet__Remove_2B595(s, x);
}

export function union(s1, s2) {
    return FSharpSet_op_Addition(s1, s2);
}

export function unionMany(sets, comparer) {
    return Seq_fold(FSharpSet_op_Addition, FSharpSet_$ctor_2528C5CB(comparer, new SetTree$1(0)), sets);
}

export function intersect(s1, s2) {
    return FSharpSet_Intersection_Z3BE9BFE0(s1, s2);
}

export function intersectMany(sets) {
    return FSharpSet_IntersectionMany_Z15B59630(sets);
}

export function iterate(f, s) {
    FSharpSet__Iterate_5028453F(s, f);
}

export function empty(comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, new SetTree$1(0));
}

export function forAll(f, s) {
    return FSharpSet__ForAll_Z1D55A0D7(s, f);
}

export function exists(f, s) {
    return FSharpSet__Exists_Z1D55A0D7(s, f);
}

export function filter(f, s) {
    return FSharpSet__Filter_Z1D55A0D7(s, f);
}

export function partition(f, s) {
    return FSharpSet__Partition_Z1D55A0D7(s, f);
}

export function fold(f, z, s) {
    return SetTreeModule_fold(f, z, FSharpSet__get_Tree(s));
}

export function foldBack(f, s, z) {
    return SetTreeModule_foldBack(f, FSharpSet__get_Tree(s), z);
}

export function map(f, s, comparer) {
    return FSharpSet__Map_7597B8F7(s, f, comparer);
}

export function count(s) {
    return FSharpSet__get_Count(s);
}

export function minimumElement(s) {
    return FSharpSet__get_MinimumElement(s);
}

export function maximumElement(s) {
    return FSharpSet__get_MaximumElement(s);
}

export function ofList(li, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_ofSeq(comparer, li));
}

export function ofArray(arr, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_ofArray(comparer, arr));
}

export function toList(s) {
    return SetTreeModule_toList(FSharpSet__get_Tree(s));
}

export function toArray(s, cons) {
    const n = count(s) | 0;
    const res = new cons(n);
    SetTreeModule_copyToArray(FSharpSet__get_Tree(s), res, 0);
    return res;
}

export function toSeq(s) {
    return SetTreeModule_toSeq(FSharpSet__get_Tree(s));
}

export function ofSeq(elements, comparer) {
    return FSharpSet_$ctor_2528C5CB(comparer, SetTreeModule_ofSeq(comparer, elements));
}

export function difference(x, y) {
    return FSharpSet_op_Subtraction(x, y);
}

export function isSubset(x, y) {
    return FSharpSet__IsSubsetOf_6A20B1FF(x, y);
}

export function isSuperset(x, y) {
    return FSharpSet__IsSupersetOf_6A20B1FF(x, y);
}

export function isProperSubset(x, y) {
    return FSharpSet__IsProperSubsetOf_6A20B1FF(x, y);
}

export function isProperSuperset(x, y) {
    return FSharpSet__IsProperSupersetOf_6A20B1FF(x, y);
}

export function minElement(s) {
    return FSharpSet__get_MinimumElement(s);
}

export function maxElement(s) {
    return FSharpSet__get_MaximumElement(s);
}

export function createMutable(source, comparer) {
    const set$ = MutableSet_MutableSet$1_$ctor_Z6150332D(source, comparer);
    return set$;
}

export function distinct(xs, comparer) {
    return Seq_delay(() => {
        const set$ = MutableSet_MutableSet$1_$ctor_Z6150332D(Seq_empty(), comparer);
        return Seq_collect((x) => (MutableSet_MutableSet$1__Add_2B595(set$, x) ? Seq_singleton(x) : Seq_empty()), xs);
    });
}

export function distinctBy(projection, xs, comparer) {
    return Seq_delay(() => {
        const set$ = MutableSet_MutableSet$1_$ctor_Z6150332D(Seq_empty(), comparer);
        return Seq_collect((x) => (MutableSet_MutableSet$1__Add_2B595(set$, projection(x)) ? Seq_singleton(x) : Seq_empty()), xs);
    });
}

export function unionWith(s1, s2) {
    return Seq_fold((acc, x) => acc.add(x), s1, s2);
}

export function intersectWith(s1, s2, comparer) {
    const s2_1 = ofSeq(s2, comparer);
    Seq_iterate((x) => {
        if (!FSharpSet__Contains_2B595(s2_1, x)) {
            const value = s1.delete(x);
            void value;
        }
        else {
        }
    }, s1);
}

export function exceptWith(s1, s2) {
    Seq_iterate((x) => {
        const value = s1.delete(x);
        void value;
    }, s2);
}

export function isSubsetOf(s1, s2, comparer) {
    return isSubset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

export function isSupersetOf(s1, s2, comparer) {
    return isSuperset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

export function isProperSubsetOf(s1, s2, comparer) {
    return isProperSubset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

export function isProperSupersetOf(s1, s2, comparer) {
    return isProperSuperset(ofSeq(s1, comparer), ofSeq(s2, comparer));
}

